<?php
/*
Plugin Name: GemConnect Integrate
Plugin URI:  https://gemstoneit.co.uk
Description: GemConnect Integrate
Version:     1.0
Author:      Gemstone IT
Author URI:  https://gemstoneit.co.uk
License:     GPL2
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: wporg
Domain Path: /languages
*/

// require_once('widget.php');
require_once('options-page.php');


//[foobar]
function gemconnect_display_calendar( $atts ){
	
	//include styles
	wp_enqueue_style('gemconnect_integrate_styles', plugin_dir_url(__FILE__) . 'css/styles.css');
	
	//get the site id
	$site_id = json_decode(file_get_contents('http://gemconnect.co.uk/api/gembookings/get_site_id_from_url/?site_url=' . get_option('gemconnect_site_url')));
	
	//get the month/year navigation position
	$navigation = get_calendar_navigation($_GET);
	
	//get the events from the api
	$first_string = "{$navigation['current_year']}-{$navigation['current_month']}-01 00:00:00";

    $first = mktime(23, 59, 59, $navigation['current_month'], 1, $navigation['current_year']);
    $last = mktime(23, 59, 59, $navigation['current_month'], date('t', strtotime($first_string)), $navigation['current_year']);
    
    $events_raw = json_decode(file_get_contents('http://gemconnect.co.uk/api/gembookings/get_site_events/?site_id=' . $site_id . '&start_time=' . $first . '&finish_time=' . $last));
    
    
    //build an array of events where the index is the day of the month where those events fall
    $event_array = array();
    
    foreach($events_raw as $key => $event) {
    	if($key == 'status') {
    		continue;
    	}
    	$day = date('j', strtotime($event->start_time));
    	
    	$event_array[$day][] = $event;
    }
	
	
	?>
        <section class="events-calendar">
            <header><h2>
                <?php echo date('F', strtotime("2012-{$navigation['current_month']}-01")); ?> 
                <span><?php echo $navigation['current_year'] ?></span>
            </h2>
            <div class="date-navigate">
                <a href="<?php the_permalink(); ?>?newmonth=<?php echo $navigation['prev_month']; ?>&newyear=<?php echo $navigation['prev_year'] ?>" class="prev"><i class="fa fa-chevron-left"></i></a><a href="<?php the_permalink(); ?>?newmonth=<?php echo $navigation['next_month']; ?>&newyear=<?php echo $navigation['next_year'] ?>" class="next"><i class="fa fa-chevron-right"></i></a>
            </div>
        </header>

            <?php
            /* draw table */
            $calendar = '<div class="calendar-header"><div cellpadding="0" cellspacing="0" class="calendar">';

            /* table headings */
            $headings = array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
            $calendar.= '<div class="calendar-row"><div class="calendar-day-head">' . implode('</div><div class="calendar-day-head">', $headings) . '</div></div></div></div>';

            /* days and weeks vars now ... */
            $running_day = date('w', mktime(0, 0, 0, $navigation['current_month'], 1, $navigation['current_year']));
            $days_in_month = date('t', mktime(0, 0, 0, $navigation['current_month'], 1, $navigation['current_year']));
            $days_in_this_week = 1;
            $day_counter = 0;

            $calendar.= '<div class="calendar-main"><div cellpadding="0" cellspacing="0" class="calendar">';

            /* row for week one */
            $calendar.= '<div class="calendar-row">';

            /* print "blank" days until the first of the current week */
            for ($x = 0; $x < $running_day; $x++) {
                $calendar.= '<div class="calendar-day-np"> </div>';
                $days_in_this_week++;
            }

            /* keep going with days.... */
            for ($list_day = 1; $list_day <= $days_in_month; $list_day++) {
                
                $calendar.= '<div class="calendar-day">';
                /* add in the day number */
                $calendar.= '<div class="day-number">' . $list_day . '</div>';

                //get the events for that day

                $e = 1;
                
                if (array_key_exists($list_day, $event_array)) {
	                foreach ($event_array[$list_day] as $event) {
	                	
	                    if ($e === 4) {
	                        $calendar .= '<div class="hide-events">';
	                    }
	                    $calendar.= '<a href="http://' . get_option('gemconnect_site_url') . '/single-event/?event_id=' . $event->id . '&start_time=' . strtotime($event->start_time) . '&finish_time=' . strtotime($event->finish_time) . '">' . date('g:ia', strtotime($event->start_time)) . ': ' . $event->name . '</a><br />';
	
	                    if ($e === count($event_array[$list_day]) && $e >= 4) {
	                        $calendar .= '</div><a class="view-more"><i class="fa fa-plus"></i>View more</a>';
	                    }
	                    
	                    $e++;
	                }
                }

                $calendar.= str_repeat('<p> </p>', 2);

                $calendar.= '</div>';
                if ($running_day == 6) {
                    $calendar.= '</div>';
                    if (($day_counter + 1) != $days_in_month) {
                        $calendar.= '<div class="calendar-row">';
                    }
                    $running_day = -1;
                    $days_in_this_week = 0;
                }
                $days_in_this_week++;
                $running_day++;
                $day_counter++;
            }

            /* finish the rest of the days in the week */
            if ($days_in_this_week < 8) {
                for ($x = 1; $x <= (8 - $days_in_this_week); $x++) {
                    $calendar.= '<div class="calendar-day-np"> </div>';
                }
            }

            /* final row */
            $calendar.= '</div>';

            /* end the table */
            $calendar.= '</div></div>';

            /* all done, return result */
            echo $calendar;
            ?>
        </section>
        <?php

}
add_shortcode( 'gemconnect_display_calendar', 'gemconnect_display_calendar' );

function get_calendar_navigation($get) {
	
	$year = null;
    $month = null;
    if (!array_key_exists('newyear', $get)) {
        $year = date('Y');
    } else {
        $year = $get['newyear'];
    }
    if (!array_key_exists('newmonth', $get)) {
        $month = date('m');
    } else {
        $month = $get['newmonth'];
    }

    if (!isset($month)) {
        $month = date('m');
    }
    if (!isset($year)) {
        $year = date('Y');
    }

    $next_year = null;
    $next_month = null;

    $prev_year = null;
    $prev_month = null;

    if ($month == 12) {
        $next_month = 1;
        $next_year = $year + 1;
    } else {
        $next_month = $month + 1;
        $next_year = $year;
    }

    if ($month == 1) {
        $prev_month = 12;
        $prev_year = $year - 1;
    } else {
        $prev_month = $month - 1;
        $prev_year = $year;
    }

    $data = array(
        'current_year' => $year,
        'current_month' => $month,
        'next_year' => $next_year,
        'next_month' => $next_month,
        'prev_year' => $prev_year,
        'prev_month' => $prev_month
    );

    return $data;
}