<?php
// create custom plugin settings menu
add_action('admin_menu', 'gemconnect_integrate_create_menu');

function gemconnect_integrate_create_menu() {

	//create new top-level menu
	add_menu_page('GemConnect Integrate Settings', 'GemConnect Integrate Settings', 'administrator', __FILE__, 'gemconnect_integrate_settings_page' );

	//call register settings function
	add_action( 'admin_init', 'register_gemconnect_integrate_settings' );
}


function register_gemconnect_integrate_settings() {
	//register our settings
	register_setting( 'gemconnect-integrate-settings-group', 'gemconnect_site_url' );
}

function gemconnect_integrate_settings_page() {
?>
<div class="wrap">
<h1>GemConnect Integrate Settings</h1>

<form method="post" action="options.php">
    <?php settings_fields( 'gemconnect-integrate-settings-group' ); ?>
    <?php do_settings_sections( 'gemconnect-integrate-settings-group' ); ?>
    <table class="form-table">
    	
        <tr valign="top">
        <th scope="row">GemConnect Site URL</th>
        <td>http:// <input type="text" name="gemconnect_site_url" value="<?php echo esc_attr( get_option('gemconnect_site_url') ); ?>" /></td>
        </tr>
         
    </table>
    
    <?php submit_button(); ?>

</form>
</div>
<?php } ?>